<?php
defined('TYPO3_MODE') or die();

/**
 * Registers the plugin to be listed in the Backend
 */
\TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
	// The extension name (in UpperCamelCase) or the extension key (in lower_underscore)
	'SJBR.' . 'sr_puzzle',
	// A unique name of the plugin in UpperCamelCase
	'Puzzle',
	// A title shown in the backend dropdown field
	'LLL:EXT:sr_puzzle/Resources/Private/Language/locallang.xlf:pi1_title',
	'EXT:sr_puzzle/ext_icon.png'
);

$pluginSignature = strtolower(\TYPO3\CMS\Core\Utility\GeneralUtility::underscoredToUpperCamelCase('sr_puzzle')) . '_puzzle';
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue('*', 'FILE:EXT:sr_puzzle/Configuration/FlexForms/form.xml', $pluginSignature);

if (\TYPO3\CMS\Core\Utility\VersionNumberUtility::convertVersionNumberToInteger(\TYPO3\CMS\Core\Utility\VersionNumberUtility::getNumericTypo3Version()) >= 7000000) {
	$coreLabelsSource = 'frontend/Resources/Private/Language/';
} else {
	$coreLabelsSource = 'cms/';
}
$GLOBALS['TCA']['tt_content']['types'][$pluginSignature]['showitem'] = '--palette--;LLL:EXT:' . $coreLabelsSource . 'locallang_ttc.xlf:palette.general;general';
$GLOBALS['TCA']['tt_content']['types'][$pluginSignature]['showitem'] .= ', --palette--;LLL:EXT:' . $coreLabelsSource . 'locallang_ttc.xlf:palette.headers;headers';
$GLOBALS['TCA']['tt_content']['types'][$pluginSignature]['showitem'] .= ',--div--;LLL:EXT:sr_puzzle/Resources/Private/Language/locallang.xlf:settings.title, pi_flexform';
$GLOBALS['TCA']['tt_content']['types'][$pluginSignature]['showitem'] .= ',--div--;LLL:EXT:' . $coreLabelsSource . 'locallang_ttc.xlf:tabs.access, --palette--;LLL:EXT:' . $coreLabelsSource . 'locallang_ttc.xlf:palette.visibility;visibility, --palette--;LLL:EXT:' . $coreLabelsSource . 'locallang_ttc.xlf:palette.access;access';
$GLOBALS['TCA']['tt_content']['types'][$pluginSignature]['showitem'] .= ', --div--;LLL:EXT:' . $coreLabelsSource . 'locallang_ttc.xlf:tabs.appearance, --palette--;LLL:EXT:' . $coreLabelsSource . 'locallang_ttc.xlf:palette.frames;frames';